/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License") you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code in this file was released on November 22, 2004
 * 
 * Unless otherwise stated, the Initial Developer of the
 * Original Code is Jordi Llonch.  Portions created by Jordi Llonch are
 * Copyright (C) 2004 Jordi Llonch.  All rights reserved.
 * 
 * Contributor(s):
 *   Jordi Llonch <jordi@laigu.net>
 *
 *
 * This code has been based on the Initial Developer of the
 * Original Code by David Perry (TagZilla Extension).  
 * Portions created by David Perry are
 * Copyright (C) 2002 David Perry.  All rights reserved.
 *   David Perry <d.perry@utoronto.ca> (Original Author)
 *
 *
 * Alternatively, the contents of this file may be used under the
 * terms of the GNU General Public License Version 2 or later (the
 * "GPL"), in which case the provisions of the GPL are applicable
 * instead of those above.  If you wish to allow use of your
 * version of this file only under the terms of the GPL and not to
 * allow others to use your version of this file under the MPL,
 * indicate your decision by deleting the provisions above and
 * replace them with the notice and other provisions required by
 * the GPL.  If you do not delete the provisions above, a recipient
 * may use your version of this file under either the MPL or the
 * GPL.
 */

////////////////////////////////////////////////////////////////////////////////
// Global Variables
////////////////////////////////////////////////////////////////////////////////
var tfCmd;      // command
var tfDoc;      // window's calling document
var tfWin;      // window's calling window
var tfChromePath;

////////////////////////////////////////////////////////////////////////////////
// ttOnLoad
//
// Parameters: (passed in through window.arguments)
//  tfCmd: text string indicating how ThunderbirdTranslator is to be used
//  tfDoc: calling document or object
//
// Returns: nothing
////////////////////////////////////////////////////////////////////////////////
function ttOnLoad() {
  try {
    include('chrome://jslib/content/io/file.js');
    include('chrome://jslib/content/io/dir.js');
    include('chrome://jslib/content/io/fileUtils.js');
    include('chrome://jslib/content/io/dirUtils.js');
  }
  catch(ex) {
    alert(getText("noJSlib"));
    window.close();
    return;
  }
  
  tfCmd = window.arguments[0];
  tfWin = window.arguments[1];
  tfDoc = tfWin.document;

  var dUtils = new DirUtils();
  tfChromePath = dUtils.getMozUserHomeDir()+"/extensions/{41f6a526-7717-4234-94f1-35ec6183de88}/chrome/";
  
  tfInsertFile();
  window.close();
}


function tfInsertFile() {
  var fName=txtFilePicker(getText("loadFile"),0,"");

  if(fName==null)
    return false;
    
  // Conversion (if it is necessary)  
  var aUrl = fName;
  aUrl = aUrl.toLowerCase();
  if(aUrl.substring(aUrl.length-4, aUrl.length)==".sxw" || aUrl.substring(aUrl.length-4, aUrl.length)==".sdw") {
	fName = openoffice2html(fName);
	if (fName==null) {
		alert(getText("notFoundMsg"));
		return -1;
	}
  }
  if(aUrl.substring(aUrl.length-4, aUrl.length)==".rtf") {
	fName = rtf2html(fName);
	if (fName==null) {
		alert(getText("notFoundMsg"));
		return -1;
	}
  }
  if(aUrl.substring(aUrl.length-4, aUrl.length)==".doc") {
	fName = msword2html(fName);
	if (fName==null) {
		alert(getText("notFoundMsg"));
		return -1;
	}
  }

  // Insert file
  var aUrl = fName;
  var aFile=fName;
  if(aUrl.substring(0,4)=="file") {
    var fUtils = new FileUtils();
    aFile = fUtils.urlToPath(aUrl);
  }
  var f = new File(aFile);
  if(!f.exists()) {
    alert(getText("notFoundMsg"));
    return -1;
  }
  f.open("r");
  var fContents = f.read();
  f.close();

  // Delete temporary file
  try {
    var fUtils2 = new FileUtils();
    fUtils2.remove(aFile);
  }
  catch(err){
    alert("An unknown error occurred.\n"+ err);
  }

  // Insert text in the editor
  var ed = tfWin.GetCurrentEditor();
  if(aUrl.substring(aUrl.length-5, aUrl.length)==".html" || aUrl.substring(aUrl.length-4, aUrl.length)==".htm") 
    ed.insertHTML(fContents);
  else 
    ed.insertText(fContents);
  
}


////////////////////////////////////////////////////////////////////////////////
// launchApp
// execute an application
//
// Parameters: file / arguments / wait untill finish (bool)
// Returns: proc.run
////////////////////////////////////////////////////////////////////////////////
function launchApp(launcher, args, wait) {
varfile=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

file.initWithPath(launcher);

if(!args) args=newArray();
varproc=Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
proc.init(file);
returnproc.run(wait===true,args,args.length);
}


////////////////////////////////////////////////////////////////////////////////
// openoffice2html
// (without images)
// using soffice2html-0.76 by Steve Slaven - http://hoopajoo.net
//
// Parameters: openoffice/staroffice file
// Returns: new name file
////////////////////////////////////////////////////////////////////////////////
function openoffice2html(file) {
	try{
		var cfile = "/tmp/content.html";
		args = new Array(file, cfile);
		launchApp(tfChromePath+"soffice2html.pl", args, true);
		return cfile;  
	} catch(err){
		alert("An unknown error occurred.\n"+ err);
	}
}


////////////////////////////////////////////////////////////////////////////////
// rtf2html
// using UnRTF By Dave Davey and Marcos Serrou do Amaral (Original Author: Zach T. Smith)
//
// Parameters: rtf file
// Returns: new name file
////////////////////////////////////////////////////////////////////////////////
function rtf2html(file) {
	try{
		var cfile = "/tmp/content.html";
		args = new Array(file, cfile);
		launchApp(tfChromePath+"unrtf2", args, true);
		return cfile;  
	} catch(err){
		alert("An unknown error occurred.\n"+ err);
	}
}


////////////////////////////////////////////////////////////////////////////////
// msword2html
// (without images)
// using wvHtml by Dom Lachowicz (dominicl@seas.upenn.edu)/Caolan McNamara (original author)
// Visit http://www.wvware.com/
//
// Parameters: msword file
// Returns: new name file
////////////////////////////////////////////////////////////////////////////////
function msword2html(file) {
	try{
		var cfile = "content.html";
		args = new Array("--targetdir=/tmp/", "--charset=iso-8859-1", file, cfile);
		launchApp("/usr/bin/wvHtml", args, true);
		var cfile = "/tmp/content.html";
		return cfile;  
	} catch(err){
		alert("An unknown error occurred.\n"+ err);
	}
}
